﻿using Microsoft.AspNetCore.Mvc;
using PagingCore.Models;

namespace PagingCore.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index(int? id)
        {
            CustomerList customerList = new CustomerList();
            customerList = CreateDummyData(Convert.ToInt32(id));
            return View(customerList);
        }

        CustomerList CreateDummyData(int page)
        {
            int pageSize = 5;
            List<Customer> cL = new List<Customer>
            {
                new Customer {Id=1, Name = "Jacky", City = "Boston"},
                new Customer {Id=2, Name = "Jack", City = "New Jersey"},
                new Customer {Id=3, Name = "Sheena", City = "Ohio"},
                new Customer {Id=4, Name = "Rohit", City = "Albany"},
                new Customer {Id=5, Name = "Mila", City = "NYC"},
                new Customer {Id=6, Name = "Sharon", City = "San Francisco"},
                new Customer {Id=7, Name = "Mark", City = "NY"},
                new Customer {Id=8, Name = "Bill", City = "Boston"},
                new Customer {Id=9, Name = "Maggi", City = "Lucknow"},
                new Customer {Id=10, Name = "Jacobs", City = "Mumbai"},
                new Customer {Id=11, Name = "Amanda", City = "Sao Paulo"},
                new Customer {Id=12, Name = "Mak", City = "Nagpur"},
                new Customer {Id=13, Name = "Rick", City = "New Jersey"},
                new Customer {Id=14, Name = "Chump", City = "Shanghai"},
                new Customer {Id=15, Name = "Sajal", City = "Albany"},
                new Customer {Id=16, Name = "Sharon", City = "San Francisco"},
                new Customer {Id=17, Name = "Mark", City = "NY"},
                new Customer {Id=18, Name = "Bill", City = "Boston"},
                new Customer {Id=19, Name = "Maggi", City = "Lucknow"},
                new Customer {Id=20, Name = "Jacobs", City = "Mumbai"},
                new Customer {Id=21, Name = "Jacky", City = "Boston"},
                new Customer {Id=22, Name = "Jack", City = "New Jersey"},
                new Customer {Id=23, Name = "Sheena", City = "Ohio"},
                new Customer {Id=24, Name = "Rohit", City = "Albany"},
                new Customer {Id=25, Name = "Mila", City = "NYC"},
                new Customer {Id=26, Name = "Sharon", City = "San Francisco"},
                new Customer {Id=27, Name = "Mark", City = "NY"},
                new Customer {Id=28, Name = "Bill", City = "Boston"},
                new Customer {Id=29, Name = "Maggi", City = "Lucknow"},
                new Customer {Id=30, Name = "Jacobs", City = "Mumbai"},
                new Customer {Id=31, Name = "Amanda", City = "Sao Paulo"},
                new Customer {Id=32, Name = "Mak", City = "Nagpur"},
                new Customer {Id=33, Name = "Rick", City = "New Jersey"},
                new Customer {Id=34, Name = "Chump", City = "Shanghai"},
                new Customer {Id=35, Name = "Sajal", City = "Albany"},
                new Customer {Id=36, Name = "Sharon", City = "San Francisco"},
                new Customer {Id=37, Name = "Mark", City = "NY"},
                new Customer {Id=38, Name = "Bill", City = "Boston"},
                new Customer {Id=39, Name = "Maggi", City = "Lucknow"},
                new Customer {Id=40, Name = "Jacobs", City = "Mumbai"}
            };
            PagingInfo pagingInfo = new PagingInfo();
            pagingInfo.CurrentPage = page == 0 ? 1 : page;
            pagingInfo.TotalItems = cL.Count();
            pagingInfo.ItemsPerPage = pageSize;

            var skip = pageSize * (Convert.ToInt32(page) - 1);
            CustomerList customerList = new CustomerList();
            customerList.PagingInfo = pagingInfo;
            customerList.Customer = cL.Skip(skip).Take(pageSize).ToList();

            return customerList;
        }
    }
}